using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace DataGridFilter
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class FormRecords : System.Windows.Forms.Form
	{

		private System.Windows.Forms.Panel panelrecords;
		private System.Windows.Forms.DataGrid DataGridRecords;
		private DataColumnCollection  TableColumnCollection;
		private DataTable  TableFilterData;

		private DataSet DataSetRecords;
		private DataView ViewRecords;
		private CheckedListBox CheckedColumns;
		private System.Windows.Forms.Button ButtonDataFilter;
		private System.Windows.Forms.Button ButtonCoulmnFilter;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public FormRecords()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.panelrecords = new System.Windows.Forms.Panel();
			this.DataGridRecords = new System.Windows.Forms.DataGrid();
			this.ButtonDataFilter = new System.Windows.Forms.Button();
			this.ButtonCoulmnFilter = new System.Windows.Forms.Button();
			this.panelrecords.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.DataGridRecords)).BeginInit();
			this.SuspendLayout();
			// 
			// panelrecords
			// 
			this.panelrecords.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.panelrecords.Controls.Add(this.DataGridRecords);
			this.panelrecords.DockPadding.Bottom = 10;
			this.panelrecords.DockPadding.Left = 10;
			this.panelrecords.DockPadding.Right = 10;
			this.panelrecords.DockPadding.Top = 10;
			this.panelrecords.Location = new System.Drawing.Point(8, 8);
			this.panelrecords.Name = "panelrecords";
			this.panelrecords.Size = new System.Drawing.Size(840, 320);
			this.panelrecords.TabIndex = 0;
			// 
			// DataGridRecords
			// 
			this.DataGridRecords.DataMember = "";
			this.DataGridRecords.Dock = System.Windows.Forms.DockStyle.Fill;
			this.DataGridRecords.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.DataGridRecords.Location = new System.Drawing.Point(10, 10);
			this.DataGridRecords.Name = "DataGridRecords";
			this.DataGridRecords.Size = new System.Drawing.Size(816, 296);
			this.DataGridRecords.TabIndex = 0;
			// 
			// ButtonDataFilter
			// 
			this.ButtonDataFilter.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.ButtonDataFilter.Location = new System.Drawing.Point(752, 336);
			this.ButtonDataFilter.Name = "ButtonDataFilter";
			this.ButtonDataFilter.Size = new System.Drawing.Size(88, 24);
			this.ButtonDataFilter.TabIndex = 1;
			this.ButtonDataFilter.Text = "Data Filter ";
			this.ButtonDataFilter.Click += new System.EventHandler(this.ButtonDataFilter_Click);
			// 
			// ButtonCoulmnFilter
			// 
			this.ButtonCoulmnFilter.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.ButtonCoulmnFilter.Location = new System.Drawing.Point(656, 336);
			this.ButtonCoulmnFilter.Name = "ButtonCoulmnFilter";
			this.ButtonCoulmnFilter.Size = new System.Drawing.Size(88, 23);
			this.ButtonCoulmnFilter.TabIndex = 2;
			this.ButtonCoulmnFilter.Text = "Coulmn Filter";
			this.ButtonCoulmnFilter.Click += new System.EventHandler(this.ButtonCoulmnFilter_Click);
			// 
			// FormRecords
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(856, 366);
			this.Controls.Add(this.ButtonCoulmnFilter);
			this.Controls.Add(this.ButtonDataFilter);
			this.Controls.Add(this.panelrecords);
			this.Name = "FormRecords";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.FormRecords_Load);
			this.panelrecords.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.DataGridRecords)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new FormRecords());
		}



		private void FormRecords_Load(object sender, System.EventArgs e)
		{
			try
			{
				//Fill the DataSet from XML file OR from any other source 
              
				DataSetRecords = new DataSet("DataSetRecords");
				
				//Make sure That Products.xml file located in the "exe" folder
				DataSetRecords.ReadXml("Products.xml", XmlReadMode.Auto );
				
				//Get the Table Column Collection
				TableColumnCollection = DataSetRecords.Tables[0].Columns;
				
				ViewRecords = DataSetRecords.Tables[0].DefaultView;
				
				DataGridTableStyle    GridStyle = new DataGridTableStyle();
				GridStyle.MappingName = DataSetRecords.Tables[0].TableName ;
				GridStyle.AlternatingBackColor=System.Drawing.Color.AliceBlue ;
				GridStyle.GridLineColor = System.Drawing.Color.MediumSlateBlue;
				
				DataGridRecords.TableStyles.Add(GridStyle);
				DataGridRecords.SetDataBinding(ViewRecords,"");
				
			}
			catch (System.Exception a_Ex)
			{
				MessageBox.Show(a_Ex.Message);
			}
		}

		private void ButtonCoulmnFilter_Click(object sender, System.EventArgs e)
		{

			ColumnFilterForm FilterForm = new ColumnFilterForm();
           
			//Set the Column Collection to the checklist object
			FilterForm.SetSourceColumns(TableColumnCollection);
			
			FilterForm.ShowDialog();

            //Get the column check list
			CheckedColumns= FilterForm.GetSelectedColumns();

			//Set The mapping Data Grid Table Style according to the selected coulmns;
			SetTableBySelectedCoulmns(DataSetRecords.Tables[0].TableName);
			
			DataGridRecords.SetDataBinding(ViewRecords,null);
		
		}

		private void ButtonDataFilter_Click(object sender, System.EventArgs e)
		{
			DataFilterForm DataFilter = new DataFilterForm();
           
			//Set the Column Collection to the filter Table
			DataFilter.SetSourceColumns(TableColumnCollection);
			
			DataFilter.ShowDialog();

			//The TableFilterData Table contains the user restriction
			TableFilterData = DataFilter.GetFilterDataTable();

			SetTableByDataFilter();

		}


		private void SetTableBySelectedCoulmns(string TableMappingName)
		{
			
			
			DataGridTableStyle    GridStyle = new DataGridTableStyle();
			
			DataGridColumnStyle   TextBoxStyle; //Use for System.Boolean only
			DataGridColumnStyle   BoolStyle; //Use for all Data Types which different form System.Boolean
			
			string CoulmnDataType;  // hold the column Data Type 
			
			try
			{
				//clear the previous Table Styles
				DataGridRecords.TableStyles.Clear();
				GridStyle.MappingName = TableMappingName;

				foreach (DataColumn Column in TableColumnCollection )
				{
					CoulmnDataType = Column.DataType.ToString();

                    // The "CheckedColumns" contains the column which the user select to show 
					// Column that not belong to the mapping will not show on the grid
                    
					if (CheckedColumns.CheckedItems.Contains(Column.ColumnName))
					{
						switch (CoulmnDataType)
						{
							// The DataGrid Coulmn Style support two major column types: Bool and Text 
							case ("System.Boolean"):
							{
								BoolStyle = new DataGridBoolColumn ();
								BoolStyle.HeaderText=Column.ColumnName;
								BoolStyle.MappingName=Column.ColumnName;
								BoolStyle.Width=100 ;
								GridStyle.GridColumnStyles.Add(BoolStyle);
							}

							break;

							default:
							{
								TextBoxStyle= new DataGridTextBoxColumn();
								TextBoxStyle.HeaderText=Column.ColumnName;
								TextBoxStyle.MappingName=Column.ColumnName;
								TextBoxStyle.Width=100;
								// The NUllText attribute enable to replace the default null value for empty cells 
								TextBoxStyle.NullText = string.Empty ;
								GridStyle.GridColumnStyles.Add(TextBoxStyle);
							}
							break;
						}
                  
					}
				}
					
				//Set the Grid Style & Color
				GridStyle.AlternatingBackColor=System.Drawing.Color.AliceBlue ;
				GridStyle.GridLineColor = System.Drawing.Color.MediumSlateBlue;
				DataGridRecords.TableStyles.Add(GridStyle);

			}
			catch (System.Exception a_Ex)
			{
				MessageBox.Show(a_Ex.Message);
			}

		}

		
		private void SetTableByDataFilter()
		{
			
         
			ViewRecords =  new DataView( DataSetRecords.Tables[0]);

			try
			{
				// Build the RowFilter statement according to the user restriction 
				foreach (DataRow FilterRow in TableFilterData.Rows)
				{
				
					if (FilterRow["Operation"].ToString() != string.Empty && FilterRow["ColumnData"].ToString() != string.Empty)
					{
						// Add the "AND" operator only from the second filter condition 
						// The RowFilter get statement which simallar to the Where condition in sql query
						// For example "GroupID = '6' AND GroupName LIKE 'A%' 
						if (ViewRecords.RowFilter == string.Empty)
						{
							ViewRecords.RowFilter = FilterRow["ColumnName"].ToString() + " " + FilterRow["Operation"].ToString() + " '" + FilterRow["ColumnData"].ToString()+"' ";
						}
					
						else
						{
							ViewRecords.RowFilter += " AND " + FilterRow["ColumnName"].ToString()+" " + FilterRow["Operation"].ToString() +" '"+ FilterRow["ColumnData"].ToString()+"'";
						}
					
					}
				}

				
				DataGridRecords.SetDataBinding(ViewRecords,"");
			}
			

			catch (System.Exception ex)
			{
              MessageBox.Show(ex.Message);
			}

		}

		
	}
}
